# TUCOPY Tucows mirroring software
# Copyright (C) 2001 Tucows Inc.
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version. 
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details. 
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


#
# vi:set tabstop=4:
# $Id: Uncompress.pm,v 1.7 2001/03/12 15:58:50 bjovanovic Exp $
# 
# Authors:
#       Leonid Igolnik <lim@tucows.com>
#       Bojan Jovanovic <bjovanovic@tucows.com>
# 

package Tucows::Mirror::Client::Uncompress;

require Exporter;
@ISA = qw( Exporter );
@EXPORT_OK = qw( uncompress_file );

use Tucows::Mirror::Config;
use Tucows::Mirror::Log;

use strict;

my ($_config, $_uncompress_mechanism, $_uncompress_dr);
my $_init = 0;

#Default delay between attempts, used if package has no defenition.
my $_delay = 30;

sub _init {
    $_config = Tucows::Mirror::Config->new();
    $_uncompress_mechanism = $_config->uncompress_mechanism || 'Zlib';
    $_uncompress_dr = 'Tucows::Mirror::Client::Uncompress::' .
					$_uncompress_mechanism . '::uncompress_file';
    eval("require Tucows::Mirror::Client::Uncompress::$_uncompress_mechanism");
    if ($@) {
        die "Unable to initialize driver for $_uncompress_mechanism: $@";
    }
	$_init = 1;
}

sub uncompress_file {
    my @args = @_;

    _init() unless $_init;

    no strict 'refs';
    return &$_uncompress_dr(@args);
}
